<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJPSOAP_Discount2 ArrayType
 * @subpackage Arrays
 */
class ArrayOfJPSOAP_Discount2 extends AbstractStructArrayBase
{
    /**
     * The ChildB
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JPSOAP_Discount[]
     */
    public $ChildB;
    /**
     * Constructor method for ArrayOfJPSOAP_Discount2
     * @uses ArrayOfJPSOAP_Discount2::setChildB()
     * @param \StructType\JPSOAP_Discount[] $childB
     */
    public function __construct(array $childB = array())
    {
        $this
            ->setChildB($childB);
    }
    /**
     * Get ChildB value
     * @return \StructType\JPSOAP_Discount[]|null
     */
    public function getChildB()
    {
        return $this->ChildB;
    }
    /**
     * Set ChildB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount[] $childB
     * @return \ArrayType\ArrayOfJPSOAP_Discount2
     */
    public function setChildB(array $childB = array())
    {
        foreach ($childB as $arrayOfJPSOAP_Discount2ChildBItem) {
            // validation for constraint: itemType
            if (!$arrayOfJPSOAP_Discount2ChildBItem instanceof \StructType\JPSOAP_Discount) {
                throw new \InvalidArgumentException(sprintf('The ChildB property can only contain items of \StructType\JPSOAP_Discount, "%s" given', is_object($arrayOfJPSOAP_Discount2ChildBItem) ? get_class($arrayOfJPSOAP_Discount2ChildBItem) : gettype($arrayOfJPSOAP_Discount2ChildBItem)), __LINE__);
            }
        }
        $this->ChildB = $childB;
        return $this;
    }
    /**
     * Add item to ChildB value
     * @throws \InvalidArgumentException
     * @param \StructType\JPSOAP_Discount $item
     * @return \ArrayType\ArrayOfJPSOAP_Discount2
     */
    public function addToChildB(\StructType\JPSOAP_Discount $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JPSOAP_Discount) {
            throw new \InvalidArgumentException(sprintf('The ChildB property can only contain items of \StructType\JPSOAP_Discount, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->ChildB[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JPSOAP_Discount|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JPSOAP_Discount|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JPSOAP_Discount|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ChildB
     */
    public function getAttributeName()
    {
        return 'ChildB';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJPSOAP_Discount2
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
